<?php

namespace App\Core\Service;

use App\Core\Repository\ChannelManagerLog\ChannelManagerLogRepository;

use App;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Config;
use Exception;
use App\Exceptions\ApiErrorException;
use Illuminate\Support\Carbon;

class ChannelManagerLogService
{

    private $channelManagerLogRepository;


    public function __construct(
        ChannelManagerLogRepository $channelManagerLogRepository
    )
    {
        $this->channelManagerLogRepository = $channelManagerLogRepository;
    }

    public function select($param = [], $column = ['*'])
    {

        $response = ['status' => -1, 'message' => '', 'data' => null];

        try {

            $data = $this->channelManagerLogRepository->findByCriteria($param, $column);

            $response = [
                'status' => true,
                'data' => $data,
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = $e->getMessage();
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);
    }

    public function create($params = [])
    {
        $response = ['status' => -1, 'message' => '', 'data' => null];
        try {

            $insertData = [
                'property_id' => fillOnUndefined($params, 'property_id'),
                'channel_manager_id' => fillOnUndefined($params, 'channel_manager_id',1),
                'type' => fillOnUndefined($params, 'type','C2E'),
                'service' => fillOnUndefined($params, 'service'),
                'request' => fillOnUndefined($params, 'request'),
                'response' => fillOnUndefined($params, 'response'),
                'ip_address' => fillOnUndefined($params, 'ip_address'),
                'status' => fillOnUndefined($params, 'status')
            ];

            $createResult = $this->channelManagerLogRepository->create($insertData);

            if ($createResult['status'] != 'success') {
                throw new Exception('api-unknown_error');
            }

            $response = [
                'status' => true,
                'data' => $createResult["data"],
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);
    }

    public function update($id, $param = [])
    {


        $response = ['status' => -1, 'message' => '', 'data' => null];
        try {


            $updateResult = $this->channelManagerLogRepository->update($id, $param);
            if ($updateResult['status'] != 'success') {
                throw new Exception('api-unknown_error');
            }
            $updateData = $updateResult["data"];
            $response = [
                'status' => true,
                'data' => $updateData,
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);
    }

}
